import { getAllMocks } from './mocks';
import { shouldWipe } from './plugins';
import { relativeWipeCheck } from "./plugins/relative";

// which one?
export var wipe = typeof __webpack_require__ === 'function' ? require('wipe-webpack-cache') : require('wipe-node-cache');

var primaryResolver = function primaryResolver(stubs, moduleName) {
  return stubs[moduleName];
};

var resolver = function resolver(stubs, moduleName) {
  // never wipe .node(native) module
  if (moduleName.indexOf('.node') > -1) {
    return false;
  }
  return 0 || shouldWipe(stubs, moduleName) || primaryResolver(stubs, moduleName) || relativeWipeCheck(stubs, moduleName);
};

var wipeCache = function wipeCache() {
  var primaryCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  wipe(primaryCache, primaryResolver);
  wipe(getAllMocks(), resolver);
};

export default wipeCache;