"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
let currentScope = null;

const setScope = exports.setScope = scope => currentScope = scope;

const getScopeVariable = exports.getScopeVariable = (name, scope = currentScope) => {
  if (name in scope) {
    return scope[name];
  }
  if (scope.parentScope) {
    return getScopeVariable(name, scope.parentScope);
  }
  return undefined;
};

const getScopeOption = exports.getScopeOption = (name, scope = currentScope) => {
  if (name in scope.options) {
    return scope.options[name];
  }
  if (scope.parentScope) {
    return getScopeOption(name, scope.parentScope);
  }
  return undefined;
};

const collectScopeVariable = exports.collectScopeVariable = (name, scope = currentScope, collect = []) => {
  if (name in scope) {
    if (Array.isArray(scope[name])) {
      collect.push(...scope[name]);
    } else {
      collect.push(scope[name]);
    }
  }
  if (scope.parentScope) {
    collectScopeVariable(name, scope.parentScope, collect);
  }
  return collect;
};

exports.default = () => currentScope;